package ${packageName}.web;
<#if table.tplCategory=="crud" >
<#if table.isShowControl==1 >
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.multipart.MultipartFile;
import com.alibaba.fastjson.JSONObject;
    <#assign Controller = "BaseCRUDJsonController">
<#else>
    <#assign Controller = "BaseCRUDJsonMappingController">
</#if>

<#else>
    <#assign Controller = "BaseCRUDJsonMappingController">
</#if>
import com.mortals.xhx.base.system.param.service.ParamService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.${Controller};
import ${packageName}.model.${ClassName}Entity;
import ${packageName}.service.${ClassName}Service;
import java.util.Map;
/**
* ${ClassName}Controller
*
* ${functionName} 控制器
*
* @author ${author}
* @date ${datetime}
*/
@RestController
@RequestMapping("${RequestMapping}")
public class ${ClassName}Controller extends ${Controller}<${ClassName}Service,${ClassName}Form,${ClassName}Entity,${pkColumn.javaType}> {

    @Autowired
    private ParamService paramService;

    public ${ClassName}Controller(){
        super.setFormClass(${ClassName}Form.class);
        super.setModuleDesc( "${functionName}");
    }

    @Override
    protected void init(HttpServletRequest request, HttpServletResponse response, ${ClassName}Form form, Map<String, Object> model, Context context) {
        <#list columns as column>
            <#if column.columnType?contains("tinyint") ||column.htmlType==3||column.htmlType==5>
        this.addDict(model, "${column.javaField}", paramService.getParamByFirstOrganize("${column.javaField}"));
            </#if>
        </#list>
        super.init(request, response, form, model, context);
    }
<#if table.isShowControl==1 >
    /**
    * 查询{functionName}
    */
    @PostMapping(value = "list")
    public String list(${ClassName}Form form) {
        try {
            return super.list(form);
        } catch (Exception e) {
            log.error("查询${functionName}列表错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
    * 编辑${functionName}
    */
    @PostMapping(value = "edit")
    public String edit(${ClassName}Form form) {
        try {
            return super.edit(form);
        } catch (Exception e) {
            log.error("编辑${functionName}错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
    * 保存${functionName}
    */
    @PostMapping(value = "save")
    public String save(${ClassName}Form form) {
        try {
            return super.save(form);
        } catch (Exception e) {
            log.error("保存${functionName}错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
    * 删除${functionName}
    */
    @PostMapping(value = "delete")
    public String delete(${ClassName}Form form) {
        try {
            return super.delete(form);
        } catch (Exception e) {
            log.error("删除${functionName}错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
    * 查看${functionName}
    */
    @PostMapping(value = "view")
    public String view(${ClassName}Form form) {
        try {
            return super.view(form);
        } catch (Exception e) {
            log.error("查看${functionName}错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
    * 逻辑删除${functionName}
    */
    @PostMapping(value = "view")
    public String logicDelete(${ClassName}Form form) {
        try {
            return super.logicDelete(form);
        } catch (Exception e) {
            log.error("逻辑删除${functionName}错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }

    /**
    * ${functionName}导入模板下载
    */
    @PostMapping(value = "downloadTemplate")
    public void downloadTemplate() {
        try {
            super.downloadTemplate();
        } catch (Exception e) {
            log.error("${functionName}导入模板下载错误", e);
        }
    }

    /**
    * ${functionName}导入
    */
    @PostMapping(value = "importData")
    public String importData(MultipartFile file, boolean updateSupport) {
        try {
            return super.importData(file,updateSupport);
        } catch (Exception e) {
            log.error("${functionName}导入错误", e);
            JSONObject ret = new JSONObject();
            ret.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            ret.put(KEY_RESULT_MSG, super.convertException(e));
            return ret.toJSONString();
        }
    }
</#if>
}